
i=1;

setSeed(i);

MRClettersPopulation = population('MRCAoA.txt','name','MRClettersPopulation','isHeader',true,'isFormatting',true);

outFilehlhf = strcat('./sample/','2x2hlhf','s','@',int2str(i),'.out.txt');
outFilehllf = strcat('./sample/','2x2hllf','s','@',int2str(i),'.out.txt');
outFilellhf = strcat('./sample/','2x2llhf','s','@',int2str(i),'.out.txt');
outFilelllf = strcat('./sample/','2x2lllf','s','@',int2str(i),'.out.txt');

highlettershighFreq = sample(16,'name','highlettershighFreq','outFile',outFilehlhf);
highletterslowFreq = sample(16,'name','highletterslowFreq','outFile',outFilehllf);
lowlettershighFreq = sample(16,'name','lowlettershighFreq','outFile',outFilellhf);
lowletterslowFreq = sample(16,'name','lowletterslowFreq','outFile',outFilelllf);

highlettershighFreq.setPop(MRClettersPopulation);
highletterslowFreq.setPop(MRClettersPopulation);
lowlettershighFreq.setPop(MRClettersPopulation);
lowletterslowFreq.setPop(MRClettersPopulation);

twoByTwoSOS = sos('reportInterval',2000, 'statTestReportStyle','full', ...
                'statInterval', 2000);

twoByTwoSOS.addSample(highlettershighFreq);
twoByTwoSOS.addSample(highletterslowFreq);
twoByTwoSOS.addSample(lowlettershighFreq);
twoByTwoSOS.addSample(lowletterslowFreq);


matchWeight = 10;

metaWeight = 0.1;
% Maximizing constraints
freqConstraint1 = twoByTwoSOS.addConstraint('name', 'freqConstraint1', 'constraintType', 'soft', 'fnc', 'orderedMax', 'stat', 'mean', 'sample1', highletterslowFreq, 'sample2', highlettershighFreq, 's1ColName', 'KFfrequency', 'S2ColName', 'KFfrequency', 'exponent', 2, 'paired', true, 'weight', 1);
freqConstraint2 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'freqConstraint2', 'constraintType', 'soft', 'fnc', 'orderedMax', 'stat', 'mean', 'sample1', lowletterslowFreq, 'sample2', lowlettershighFreq, 's1ColName', 'KFfrequency', 'S2ColName', 'KFfrequency', 'exponent', 2, 'paired', true, 'weight', 1);
lettersConstraint1 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'lettersConstraint1', 'constraintType', 'soft', 'fnc', 'orderedMax', 'stat', 'mean', 'sample1', lowletterslowFreq, 'sample2', highletterslowFreq, 's1ColName', 'letters', 'S2ColName', 'letters', 'exponent', 2, 'paired', true, 'weight', 1);
lettersConstraint2 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'lettersConstraint2', 'constraintType', 'soft', 'fnc', 'orderedMax', 'stat', 'mean', 'sample1', lowlettershighFreq, 'sample2', highlettershighFreq, 's1ColName', 'letters', 'S2ColName', 'letters', 'exponent', 2, 'paired', true, 'weight', 1.0);

% Minimizing constraints and meta-constraints
freqConstraint3 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'freqConstraint3', 'constraintType', 'soft', 'fnc', 'min', 'stat', 'mean', 'sample1', lowletterslowFreq, 'sample2', highletterslowFreq, 's1ColName', 'KFfrequency', 'S2ColName', 'KFfrequency', 'exponent', 2, 'paired', true, 'weight', 1);
freqConstraint4 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'freqConstraint4', 'constraintType', 'soft', 'fnc', 'min', 'stat', 'mean', 'sample1', lowlettershighFreq, 'sample2', highlettershighFreq, 's1ColName', 'KFfrequency', 'S2ColName', 'KFfrequency', 'exponent', 2, 'paired', true, 'weight', 1);
lettersConstraint3 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'lettersConstraint3', 'constraintType', 'soft', 'fnc', 'min', 'stat', 'mean', 'sample1', highlettershighFreq, 'sample2', highletterslowFreq, 's1ColName', 'letters', 'S2ColName', 'letters', 'exponent', 2, 'paired', true, 'weight', 1);
lettersConstraint4 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'lettersConstraint4', 'constraintType', 'soft', 'fnc', 'min', 'stat', 'mean', 'sample1', lowlettershighFreq, 'sample2', lowletterslowFreq, 's1ColName', 'letters', 'S2ColName', 'letters', 'exponent', 2, 'paired', true, 'weight', 1);

imagConstraint1 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'imagConstraint1', 'constraintType', 'soft', 'fnc', 'min', 'stat', 'mean', 'sample1', lowletterslowFreq, 'sample2', highletterslowFreq, 's1ColName', 'imagery', 'S2ColName', 'imagery', 'exponent', 2, 'paired', true, 'weight', 0.0001);
imagConstraint2 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'imagConstraint2', 'constraintType', 'soft', 'fnc', 'min', 'stat', 'mean', 'sample1', lowletterslowFreq, 'sample2', lowlettershighFreq, 's1ColName', 'imagery', 'S2ColName', 'imagery', 'exponent', 2, 'paired', true, 'weight', 0.0001);
imagConstraint3 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'imagConstraint3', 'constraintType', 'soft', 'fnc', 'min', 'stat', 'mean', 'sample1', highlettershighFreq, 'sample2', highletterslowFreq, 's1ColName', 'imagery', 'S2ColName', 'imagery', 'exponent', 2, 'paired', true, 'weight', 0.0001);
imagConstraint4 = twoByTwoSOS.addConstraint('sosObj', twoByTwoSOS, 'name', 'imagConstraint4', 'constraintType', 'soft', 'fnc', 'min', 'stat', 'mean', 'sample1', highlettershighFreq, 'sample2', lowlettershighFreq, 's1ColName', 'imagery', 'S2ColName', 'imagery', 'exponent', 2, 'paired', true, 'weight', 0.0001);


metaConstraint1 = twoByTwoSOS.addConstraint('name', 'metaConstraint1', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', freqConstraint3, 'constraint2', freqConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint2 = twoByTwoSOS.addConstraint('name', 'metaConstraint2', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', freqConstraint3, 'constraint2', freqConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint3 = twoByTwoSOS.addConstraint('name', 'metaConstraint3', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', freqConstraint3, 'constraint2', lettersConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint4 = twoByTwoSOS.addConstraint('name', 'metaConstraint4', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', freqConstraint3, 'constraint2', lettersConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);


metaConstraint5 = twoByTwoSOS.addConstraint('name', 'metaConstraint5', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', freqConstraint4, 'constraint2', freqConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint6 = twoByTwoSOS.addConstraint('name', 'metaConstraint6', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', freqConstraint4, 'constraint2', freqConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint7 = twoByTwoSOS.addConstraint('name', 'metaConstraint7', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', freqConstraint4, 'constraint2', lettersConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint8 = twoByTwoSOS.addConstraint('name', 'metaConstraint8', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', freqConstraint4, 'constraint2', lettersConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);



metaConstraint9 = twoByTwoSOS.addConstraint('name', 'metaConstraint9', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', lettersConstraint3, 'constraint2', freqConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint10 = twoByTwoSOS.addConstraint('name', 'metaConstraint10', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', lettersConstraint3, 'constraint2', freqConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint11 = twoByTwoSOS.addConstraint('name', 'metaConstraint11', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', lettersConstraint3, 'constraint2', lettersConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint12 = twoByTwoSOS.addConstraint('name', 'metaConstraint12', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', lettersConstraint3, 'constraint2', lettersConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);


metaConstraint13 = twoByTwoSOS.addConstraint('name', 'metaConstraint13', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', lettersConstraint4, 'constraint2', freqConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint14 = twoByTwoSOS.addConstraint('name', 'metaConstraint14', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', lettersConstraint4, 'constraint2', freqConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint15 = twoByTwoSOS.addConstraint('name', 'metaConstraint15', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', lettersConstraint4, 'constraint2', lettersConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint16 = twoByTwoSOS.addConstraint('name', 'metaConstraint16', 'constraintType', 'meta', 'fnc', 'matchCostNotMin', 'constraint1', lettersConstraint4, 'constraint2', lettersConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);


metaConstraint17 = twoByTwoSOS.addConstraint('name', 'metaConstraint1', 'constraintType', 'meta', 'fnc', 'matchCost', 'constraint1', freqConstraint1, 'constraint2', lettersConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint18 = twoByTwoSOS.addConstraint('name', 'metaConstraint1', 'constraintType', 'meta', 'fnc', 'matchCost', 'constraint1', freqConstraint2, 'constraint2', lettersConstraint1, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint19 = twoByTwoSOS.addConstraint('name', 'metaConstraint1', 'constraintType', 'meta', 'fnc', 'matchCost', 'constraint1', freqConstraint1, 'constraint2', lettersConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);
metaConstraint20 = twoByTwoSOS.addConstraint('name', 'metaConstraint1', 'constraintType', 'meta', 'fnc', 'matchCost', 'constraint1', freqConstraint2, 'constraint2', lettersConstraint2, 'constraint2costScale', 1.0, 'weight', metaWeight);



twoByTwoSOS.initFillSamples();


twoByTwoSOS.addttest('name', 'frequencyTest1', 'type', 'paired', 'sample1', highlettershighFreq, 'sample2', highletterslowFreq, 's1ColName', 'KFfrequency', 's2ColName', 'KFfrequency', 'desiredpvalCondition', '<=', 'desiredpval',.05);
twoByTwoSOS.addttest('name', 'frequencyTest2', 'type', 'paired', 'sample1', lowlettershighFreq, 'sample2', lowletterslowFreq, 's1ColName', 'KFfrequency', 's2ColName', 'KFfrequency', 'desiredpvalCondition', '<=', 'desiredpval',.05);
twoByTwoSOS.addttest('name', 'lettersTest1', 'type', 'paired', 'sample1', highlettershighFreq, 'sample2', lowlettershighFreq, 's1ColName', 'letters', 's2ColName', 'letters', 'desiredpvalCondition', '<=', 'desiredpval',.05);
twoByTwoSOS.addttest('name', 'lettersTest2', 'type', 'paired', 'sample1', highletterslowFreq, 'sample2', lowletterslowFreq, 's1ColName', 'letters', 's2ColName', 'letters', 'desiredpvalCondition', '<=', 'desiredpval',.05);

twoByTwoSOS.addttest('name', 'frequencyTest3', 'type', 'paired', 'sample1', highlettershighFreq, 'sample2', lowlettershighFreq, 's1ColName', 'KFfrequency', 's2ColName', 'KFfrequency', 'desiredpvalCondition', '=>', 'desiredpval', .5,'thresh',5);
twoByTwoSOS.addttest('name', 'frequencyTest4', 'type', 'paired', 'sample1', highletterslowFreq, 'sample2', lowletterslowFreq, 's1ColName', 'KFfrequency', 's2ColName', 'KFfrequency', 'desiredpvalCondition', '=>', 'desiredpval', .5,'thresh',5);
twoByTwoSOS.addttest('name', 'lettersTest3', 'type', 'paired', 'sample1', highlettershighFreq, 'sample2', highletterslowFreq, 's1ColName', 'letters', 's2ColName', 'letters', 'desiredpvalCondition', '=>', 'desiredpval',.5,'thresh',0.5);
twoByTwoSOS.addttest('name', 'lettersTest4', 'type', 'paired', 'sample1', lowlettershighFreq, 'sample2', lowletterslowFreq, 's1ColName', 'letters', 's2ColName', 'letters', 'desiredpvalCondition', '=>', 'desiredpval',.5, 'thresh',0.5);

twoByTwoSOS.addttest('name', 'imagTest1', 'type', 'paired', 'sample1', lowletterslowFreq, 'sample2', lowlettershighFreq, 's1ColName', 'imagery', 's2ColName', 'imagery', 'desiredpvalCondition', '=>', 'desiredpval',.5, 'thresh',50);
twoByTwoSOS.addttest('name', 'imagTest2', 'type', 'paired', 'sample1', lowletterslowFreq, 'sample2', highletterslowFreq, 's1ColName', 'imagery', 's2ColName', 'imagery', 'desiredpvalCondition', '=>', 'desiredpval',.5, 'thresh',50);
twoByTwoSOS.addttest('name', 'imagTest3', 'type', 'paired', 'sample1', highlettershighFreq, 'sample2', highletterslowFreq, 's1ColName', 'imagery', 's2ColName', 'imagery', 'desiredpvalCondition', '=>', 'desiredpval',.5, 'thresh',50);
twoByTwoSOS.addttest('name', 'imagTest4', 'type', 'paired', 'sample1', highlettershighFreq, 'sample2', lowlettershighFreq, 's1ColName', 'imagery', 's2ColName', 'imagery', 'desiredpvalCondition', '=>', 'desiredpval',.5, 'thresh',50);

twoByTwoSOS.maxIt = 10000000;

ind(i) = i;
outcomes(i) = twoByTwoSOS.optimize();

twoByTwoSOS.writeSamples();

twoByTwoSOS.dispCost();
